#!/usr/bin/env python
# coding=utf-8
#
# Copyright © Splunk, Inc. All Rights Reserved.

from __future__ import absolute_import, division, print_function, unicode_literals
from slim.utils import encode_series, encode_string
import sys

commands = {
    'config':               __import__('slim.config', fromlist=['main']).main,
    'describe':             __import__('slim.describe', fromlist=['main']).main,
    'generate-manifest':    __import__('slim.generate_manifest', fromlist=['main']).main,
    'package':              __import__('slim.package', fromlist=['main']).main,
    'partition':            __import__('slim.partition', fromlist=['main']).main,
    'update-installation':  __import__('slim.update_installation', fromlist=['main']).main,
    'validate':             __import__('slim.validate', fromlist=['main']).main
}


def main(argv=None):

    if argv is None:
        argv = sys.argv

    # TODO: SPL-120629, Add help command and if we've got no args, execute the help command

    if len(argv) < 2:
        print('Expected a SLIM command:', encode_series(sorted(commands), 'or'), file=sys.stderr)
        sys.exit(1)

    command = argv[1]

    if command not in commands:
        print(encode_string(command), 'is not a SLIM command', file=sys.stderr)
        sys.exit(1)

    commands[command](argv[1:])


if __name__ == '__main__':
    main(sys.argv)
