#!/usr/bin/env python
# coding=utf-8
#
# Copyright © Splunk, Inc. All Rights Reserved.

from __future__ import absolute_import, division, print_function, unicode_literals
import unittest

from glob import glob
from os import path

import sys


def test_variants(test_case, file, pattern):
    test_dir = path.abspath(path.splitext(file)[0])
    pattern = path.join(test_dir, pattern)
    success = True

    for filename in sorted(glob(pattern)):
        setattr(test_case, 'count', getattr(test_case, 'count', 0) + 1)
        test_case.path = path.join(test_dir, filename)
        program = unittest.main(exit=False)
        success = success and not (program.result.errors or program.result.failures)

    sys.exit(0 if success else 1)
