# This file will execute Pylint while setting up the PYTHONPATH properly. The
# reason this is needed is because Pylint is very particular about the paths,
# and on Jenkins it gets confused about how to properly find some of the SLIM
# code.

from __future__ import absolute_import, division, print_function, unicode_literals
import os
import sys

from pylint.lint import Run

# CMake will pass us the arguments for pylint as the last two args, so we get it and run it

sys.path.insert(0, os.path.dirname(os.path.abspath(sys.argv[-1])))
pylint_args = sys.argv[-2:]

print('Executing pylint with args: {0}'.format(pylint_args))
print('SPLUNK_HOME =', os.environ['SPLUNK_HOME'])
print('sys.path =\n ', '\n  '.join(sys.path))

try:
    import slim
except ImportError as error:
    print('Could not import slim:', error)
    sys.exit(1)

Run(pylint_args)
